题目描述
Given an array of integers, return indices of the two numbers such that they add up to a specific target. You may assume that each input would have exactly one solution.
Example:Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
思路
无序数组。返回的索引值 index1 < index2。a + b = target,遍历到a,我们想为它找到
b = target - a,可以使用HashMap来实现 O(1)查找,以空间换时间。整体时间复杂度O(n)。遍历nums数组,对于nums[i], 查看target - nums[i]在不在HashMap中,如果不在,把nums[1]和它的索引值放到HashMap;如果在,那么把nums[i]的配对值target - nums[1]的索引值取出来,而且这个取出来的索引值是先于nums[i]出现的。所以这个索引值小于i,返回的两个索引值注意顺序。
解法
import java.util.HashMap;
import java.util.Map;
public class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
for(int i = 0; i < nums.length; i++){
if (map.containsKey(target - nums[i])){
return new int[]{map.get(target - nums[i]), i};
}
else{
map.put(nums[i], i);
}
}
return null;
}
}
注意
- 返回值index1和index2的顺序别弄错。
- map.put进去的东西一定是两个值,key-value pair,不要只把key放进去了。
网友评论